/**
 * 
 * #适应性配置
 * 
 */

// * 允许使用require
const require = createRequire(import.meta.url)
// * 替换__dirname
const __dirname = path.dirname(fileURLToPath(import.meta.url))
// * 禁止页面控制台显示安全警告
process.env['ELECTRON_DISABLE_SECURITY_WARNINGS'] = 'true'


/**
 * 
 * # 全局配置
 * 
 */

// * 主进程发送给渲染进程消息的通道
global.MainChanleName = 'Electron.Main.Message'
// * 主进程接收渲染进程消息的通道
global.RenderChanleName = 'Electron.IpcRenderer.Message'
// * 主进程初始化状态
global.windowLoaded = false;
// * 程序启动时间
global.startTime = new Date().getTime();
// * 根目录
global.ROOT_DIR = path.join(__dirname, '../..')
console.log('root dir:', ROOT_DIR)
// * 主进程目录
global.ELECTRON_DIR = path.join(__dirname)
console.log('electron dir:', ELECTRON_DIR)
// * 渲染进程目录
global.RENDER_DIR = path.join(__dirname, '../../out-render')
console.log('render dir:', RENDER_DIR)
// * resource目录
global.RESOURCE_DIR = path.join(__dirname, '../../../app.asar.unpacked')
console.log('resource dir')
// * 是否是开发环境
global.isDev = process.env.NODE_ENV !== 'production' && process.env.NODE_ENV !== undefined;
console.log('node env:', process.env.NODE_ENV)

import { app, BrowserWindow } from 'electron'
import { createRequire } from 'node:module'
import { fileURLToPath } from 'node:url'
import path from 'node:path'
import { runTask } from "./task/task.js";

function createWindow() {
    const win = new BrowserWindow({
        width: 1280,
        height: 800,
        show: false,
        icon: path.join(RENDER_DIR, 'public/electron-vite.svg'),
        webPreferences: {
            nodeIntegration: false,
            contextIsolation: true,
            // 设置CSP
            contentSecurityPolicy: "script-src 'self'; object-src 'self'",
            devTools: true,
            preload: path.join(__dirname, 'preload.mjs'),
        },
        frame: false // 设置无边框
    })

    runTask(win)
    // 还原窗口
    win.restore();

    if (isDev) {
        console.log('开发模式')
        win.loadURL('http://localhost:17129')
    } else {
        // win.loadFile('dist/index.html')
        win.loadFile(path.join(RESOURCE_DIR,'out-render', 'index.html'))
    }
}

app.whenReady().then(createWindow)

app.on('window-all-closed', () => {
    if (process.platform !== 'darwin') {
        app.quit()
    }
})
