// | ------------------------------------------------------------
// | @版本: version 0.1
// | @创建人: 【Nie-nie】
// | @E-mail: x71291@outlook.com
// | @所在项目: js-ii-pad-linux
// | @文件描述: connectServer.js -
// | @创建时间: 2024-11-12 09:36
// | @更新时间: 2024-11-12 09:36
// | @修改记录:
// | -*-*-*-  (时间--修改人--修改说明)  -*-*-*-
// | =
// | ------------------------------------------------------------

import * as dgram from "node:dgram";
import {sleep} from "../../tools/sleep.js";

export function connectServer(host) {
    return new Promise(async (resolve, reject) => {
        let status = false;
        const udpClient = dgram.createSocket('udp4');
        udpClient.on('error', (err) => {
            const errMsg = `在尝试连接服务器的UDP客户端出现故障 ${err}`
            reject(errMsg);
            udpClient?.close();
        });
        udpClient.on('message', (msg, rinfo) => {
            if(msg.indexOf('serverAddress') === 0){
                status = true;
                resolve(rinfo);
                udpClient?.close();
            }
        });
        udpClient.on('close', () => {
            console.log(`尝试连接服务器的UDP客户端已关闭`)
        })
        console.log(`尝试连接服务器的UDP客户端已建立`);
        const testCount = 8
        for (let i = 0; i < testCount; i++) {
            if(status){
                break;
            }
            udpClient.send('checkAddress', 38600, host, (err) => {
                if(err){
                    reject(`UDP消息发送失败${err}`)
                    udpClient?.close();
                }else{
                }

                const address = udpClient.address();
            });
            if(i + 1 < testCount) {
                await sleep(1000);
            }else{
                await sleep(1000);
                reject('尝试连接服务器超时!')
                udpClient?.close();
            }
        }
        udpClient.on('listening', async () => {

        });
    })
}
