// | ------------------------------------------------------------
// | @版本: version 0.1
// | @创建人: 【Nie-nie】
// | @E-mail: x71291@outlook.com
// | @所在项目: js-ii-pad-linux
// | @文件描述: task.js -
// | @创建时间: 2024-11-12 10:00
// | @更新时间: 2024-11-12 10:00
// | @修改记录:
// | -*-*-*-  (时间--修改人--修改说明)  -*-*-*-
// | =
// | ------------------------------------------------------------


import {initializationRender} from "./task_00_initializationRender.js";
import {createIpcChannel} from "./task_01_createIpcChannel.js";
import {connectDB} from "./task_02_connectDB.js";
import {checkServerHost} from "./task_03_checkServerHost.js";
import {getDeviceBinding} from "./task_04_getDeviceBinding.js";

export async function runTask(win){
    // task0 设置渲染线程
    initializationRender(win)
    // task1 创建通信通道
    createIpcChannel(win)
    // 连接数据库，初始化配置信息
    await connectDB()
    // 检测服务器地址,++++++++同时等待渲染器渲染成功，所有消息在本任务之后发送
    await checkServerHost(win).then(res => {})
    // 获取谁被绑定信息
    getDeviceBinding(win).then(res => {})

    win.webContents.setZoomLevel(0)
    console.log(win.webContents.getZoomLevel())
}
