// | ------------------------------------------------------------
// | @版本: version 0.1
// | @创建人: 【Nie-nie】
// | @E-mail: x71291@outlook.com
// | @所在项目: js-ii-pad-linux
// | @文件描述: task_02_connectDB.js -
// | @创建时间: 2024-11-12 10:25
// | @更新时间: 2024-11-12 10:25
// | @修改记录:
// | -*-*-*-  (时间--修改人--修改说明)  -*-*-*-
// | =
// | ------------------------------------------------------------
import sqlite3 from 'better-sqlite3';
import path from 'node:path';
// import {systemConfig} from "./db/modules/systemConfig.js";
// 连接数据库
export async function connectDB() {
    console.log('DB_FILE', path.join(global.RESOURCE_DIR, 'database.sqlite'))
    const db = new sqlite3(path.join(global.RESOURCE_DIR, 'database.sqlite'));
    db.pragma('journal_mode = WAL');
    global.DB = db;
    await initTable()
    await getSystemConfig()
    return;
}

async function initTable() {
    const SQL = `CREATE TABLE IF NOT EXISTS "SystemConfigs" (
  "id" INTEGER PRIMARY KEY AUTOINCREMENT,
  "key" VARCHAR(255) NOT NULL,
  "value" VARCHAR(255) NOT NULL,
  UNIQUE ("key" ASC)
);`
    await global.DB.prepare(SQL).run()
}

// 加载模型
function mountedModules(sequelize) {
    return new Promise((resolve, reject) => {
        // 逐个加载模型
        const SystemConfig = sequelize.define(
            'SystemConfig',
            systemConfig
        )
        sequelize.sync().then(() => {
            resolve({
                modules: {
                    SystemConfig
                },
                sequelize
            })
        });
    })
}

// 获取系统参数
export async function getSystemConfig() {
    const selectStmt = global.DB.prepare("SELECT * FROM SystemConfigs;");
    const data = await selectStmt.all();
    console.log('TEST', data)
    const systemConfigObject = {}
    data.forEach(item => {
        let content = item.value
        if (['DeviceBinding'].includes(item.key)) {
            try {
                content = JSON.parse(content)
            } catch (err) {
                content = undefined
            }
        }
        systemConfigObject[item.key] = content

    })
    console.log('系统配置信息', systemConfigObject)
    global.SystemConfig = systemConfigObject
    return
}
