// | ------------------------------------------------------------
// | @版本: version 0.1
// | @创建人: 【Nie-nie】
// | @E-mail: x71291@outlook.com
// | @所在项目: js-ii-pad-linux
// | @文件描述: ipcRequest.js -
// | @创建时间: 2024-11-26 10:46
// | @更新时间: 2024-11-26 10:46
// | @修改记录:
// | -*-*-*-  (时间--修改人--修改说明)  -*-*-*-
// | =
// | ------------------------------------------------------------


const IPC_NAME = import.meta.env.VITE_ELECTRON_IPC_MESSAGE_NAME
export default async function ipcInvoke(path, data){
    console.log(`%c<<=== IPC_INVOKE ${path}`, consoleColor.ipcInvoke.IN, data || '')
    const response = await window?.ipcRenderer?.invoke(IPC_NAME, {
        path,
        data
    })
    console.log(`%c===>> IPC_INVOKE ${path}`, consoleColor.ipcInvoke.TO, data)
    if(response.code !== 200){
        const e = new Error()
        e.message = response.message
        e.code = response.code
        e.errorData = response.data
        throw e
    }else{
        return response
    }
}
