// | ------------------------------------------------------------
// | @版本: version 0.1
// | @创建人: 【Nie-x7129】
// | @E-mail: x71291@outlook.com
// | @所在项目: js-ii-pad-linux
// | @文件描述: authorization.js -
// | @创建时间: 2024-11-04 14:15
// | @更新时间: 2024-11-04 14:15
// | @修改记录:
// | -*-*-*-  (时间--修改人--修改说明)  -*-*-*-
// | =
// | ------------------------------------------------------------

import { useSystemStore } from '@/stores/system.js';
import { useIpcStore } from "@/stores/ipc.js";

export default function authRouter(app, option) {
    const { router } = option;
    const systemStore = useSystemStore();
    const ipcStore = useIpcStore();



    router.beforeEach(async (to, from) => {
        console.log('%c<<=== ROUTER', consoleColor.router.IN, from.path)
        console.log('%c===>> ROUTER', consoleColor.router.TO, to.path)
        // 核心条件1: 服务器地址明确
        const condition1 = ipcStore.state.serverHostInit === 1;
        // 核心条件2: 设备绑定过
        const condition2 = systemStore.state.deviceBinding !== undefined;
        // 核心条件3: 存在登录用户
        const condition3 = systemStore.state.onlineUserList.length !== 0
        if(condition1 && condition2 && condition3){
            return true;
        }else{
            if(!condition1 && to.path !== '/initialization'){
                // 服务器地址未初始化
                return router.push('/initialization');
            }
            if(condition1 && !condition2 && to.path !== '/deviceBinding'){
                // 设备信息未绑定
                return router.push('/deviceBinding');
            }
            if(condition1 && condition2 && !condition3 && to.path !== '/login'){
                // 不存在登录用户
                return router.push('/login');
            }
        }
        // ? 判断是否在白名单
        if (systemStore.state.routeWhiteList.includes(to.path)) {
            return true;
        }

        // ? 其他均在权限范围内
    });

    router.afterEach(async (to, from) => {
        // console.log('AFETR AUTH ROUTER');
    });
}
